var fs = require("fs");
var path = require('path');

//
// setup DOM-like sandbox
//

var window = {};
var loader;

var script = function(inPath) {
	eval(fs.readFileSync(inPath, "utf8"));
};

var chunks = [];

var pushChunkFile = function(inType, inFile) {
	var chunk = chunks.slice(-1)[0];
	if (!chunk || !chunk[inType]) {
		chunk = { sheets:[], scripts:[] };
		chunks.push(chunk);
	}
	chunk[inType].push(inFile);
};

module.exports = {
	init: function(inEnyoPath, inLibPath, inMapFrom, inMapTo) {
		// Always use the Enyo loader that comes with _this_ walker
		script(path.join(__dirname, "..", "..", "..", "..", "enyo", "loader.js"));
		enyo.path.addPaths({
			enyo: inEnyoPath,
			lib: inLibPath
		});
		var checkMapping = function(inFile, inIsPackage) {
			if (inMapFrom) {
				var relPath = path.relative(process.cwd(), inFile);
				var dir = path.dirname(relPath);
				var base = path.basename(relPath);
				var mapIdx = inMapFrom.indexOf(dir);
				if (mapIdx >= 0) {
					var to = inMapTo[mapIdx];
					var chunk = path.join(to, base);
					chunks.push(chunk);
					if (inIsPackage) {
						loader.more.apply(loader);
					}
					return true;
				}
			}
			return false;
		};
		loader = new enyo.loaderFactory({
			script: function(inScript) {
				if (!checkMapping(inScript)) {
					pushChunkFile("scripts", inScript);
				}
			},
			sheet: function(inSheet) {
				if (!checkMapping(inSheet)) {
					pushChunkFile("sheets", inSheet);
				}
			}
		});
		loader.loadPackage = function(inScript) {
			if (!checkMapping(inScript, true)) {
				script(inScript);
			}
		};
		enyo.depends = function() {
			//console.log(arguments);
			loader.load.apply(loader, arguments);
		};
	},
	walk: function(inScript, inCallback) {
		//console.log("walking: ", inScript);
		loader.finish = function() {
			inCallback(loader, chunks);
		};
		script(enyo.path.rewrite(inScript));
	}
}
